﻿/**
ビルド用。

DMD単体でも別にかまわないけどNeGuiはbud使用が前提。

WinMainを使用する場合は特に指定無し。
mainを使用する場合は-version=CUIが必要。

バージョンやらdefファイルは一応の設定。
環境で変更が必要かも。

Bud:
	defファイルにはには$(STRONG EXETYPE NT)が付加される。
	
	versionが$(EMPHASIS CUI)であれば$(STRONG SUBSYSTEM CONSOLE, 5.0)、それ以外は$(STRONG SUBSYSTEM WINDOWS, 5.0)が付加される。

	コマンドラインオプションとしては
	$(LIST_UNORDERED
		$(LIST_ITEM $(EMPHASIS Unicode))
		$(LIST_ITEM $(EMPHASIS WindowsXP))
		$(LIST_ITEM $(EMPHASIS IE7))
	)
	上記三つが自動的に定義される。

	$(D_COMMENT
		2000でも使えたらいいなぁと思いつつSUBSYSTEM CONSOLE, 5.0で定義。
		でもAPI使いたいからversion=WindowsXPでビルド。
	)

*/
module etc.negui.builder;

version(build) {
	pragma(build_def, "EXETYPE NT");
	
	version(CUI) {
		pragma(build_def, "SUBSYSTEM CONSOLE, 5.0");
	} else {
		pragma(build_def, "SUBSYSTEM WINDOWS, 5.0");
	}
	
	pragma(export_version, Unicode);
	pragma(export_version, WindowsXP);
	pragma(export_version, IE7);
}

