﻿/**
あ
*/
module etc.negui.control.listbox.header;

debug import std.stdio: wl = writefln;
debug(header) void main() {}

import std.exception;

import win32.windows;
import win32.commctrl;

import etc.negui.system.base;
public import etc.negui.negui;
public import etc.negui.control.control;

///
class HeaderException: ControlException {
	mixin MixInNeGuiException;
}

/***/
class Header: Control, ICommonControl {
	mixin MixInCommonControl;
	/**
	*/
	override protected this(HWND hWnd) {
		super(hWnd);
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_P 処理内容変更。)
		)
	*/
	this(NeGui Owner, ITEM_ID Id) {
		NEGUIINFO NeGuiInfo;
		
		NeGuiInfo.owner     = Owner;
		NeGuiInfo.id        = Id;
		
		this(NeGuiInfo);
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	override this(ref NEGUIINFO NeGuiInfo) {
		NeGuiInfo.className = Text(WC_HEADER);
		super(NeGuiInfo);
	}

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 属性変更。)
		)
	*/
	const size_t count() {
		auto len = send(HDM_GETITEMCOUNT, NONE, NONE);
		enforce(len != -1, new HeaderException(Text("ヘッダーアイテム数取得失敗")));
		return len;
	}
}

