﻿/**

History:
	$(HIST_VER 1.130,
		$(HIST_NEW)
	)
*/
module etc.negui.system.exception_hide;

debug import std.stdio: wl = writefln;
debug(exception_hide) void main() {}

import std.string;

class NeGuiBaseException: Exception {
	this(string msg, Throwable next=null, string _file=__FILE__, int _line=__LINE__) {
		super(msg, _file, _line, next);
	}
	/**
	History:
		$(HIST_VER 1.130,
			$(HIST_NEW)
		)
	*/
	protected const string ExceptionMessage() {
		return format(
			"%s@%s(%s): %s",
			this.classinfo.name,
			file,
			line,
			msg
		);
	}
	
	/**
	History:
		$(HIST_VER 1.130,
			$(HIST_CHG 所属, etc.negui.system.exception.NeGuiException, etc.negui.system._hide.exception.NeGuiBaseException)
		)
		$(HIST_VER 1.032,
			$(HIST_P 処理内容変更。)
		)
	*/
	override string toString() {
		auto s=ExceptionMessage();
		
		if(next) {
			s ~= newline ~ next.toString;
		}

		return s;
	}
}
