﻿/**

*/
module etc.negui.system.meta.basic;

debug import std.stdio: wl = writefln;
debug(basic) void main() {}

/**
くっつけ。

History:
	$(HIST_VER 1.130,
		$(HIST_CHG第二引数の型, T..., string[] ...)
	)
*/
//pure nothrow string join(T...)(in string sep, in T words)
pure nothrow string join(in string sep, in string[] words ...)
in {
	assert(words.length);
}
body {
	string s;
	
	foreach(word; words) {
		if(s.length) {
			s ~= sep;
		}
		s ~= word;
	}

	return s;
}
debug(basic) unittest {
	pragma(msg, join("","#"));
}

//　なにこれ？　動くの？
pure nothrow string[] splitlines(in string words)
in {
	assert(words.length);
}
out(r) {
	foreach(word; r) {
		foreach(c; word) {
			assert(c != '\r' && c != '\n');
		}
	}
}
body {
	string[] s;
	size_t head;
	
	for(auto i=0; i < words.length; i++) {
		if(head - i > 0 && (words[i] == '\r' || words[i] == '\n')) {
			s ~= words[head..i];
			head = i + 1;
			continue;
		} else if(words[i] == '\r' || words[i] == '\n') {
			head++;
		}
	}

	return s;
}

debug(basic) unittest {
	pragma(msg, splitlines("a\r\nb"));
}


