﻿/**
比較。

なんとなく。

History:
	$(HIST_VER 1.021,
		$(HIST_NEW)
	)
*/
module etc.negui.system.utility.cmp;

debug import std.stdio: wl = writefln;
debug(cmp) void main() {}

import std.traits;
//import etc.negui.system.utility.array; // Error: struct etc.negui.system.text.Text no size yet for forward reference
//import etc.negui.system.text;
//import etc.negui.system.exception;
//import etc.negui.system.literal;
/+
///
class NeGuiCmpException: NeGuiException {
	mixin MixInNeGuiException;
}
+/


/**
History:
	$(HIST_VER 1.130,
		$(HIST_CHG 引数, T, in T)
	)
*/
int Cmp(T)(in T a, in T b) {
	if(a == b) {
		return 0;
	}
	if(a > b) {
		return +1;
	}
	return -1;
}
debug(cmp) unittest {
	assert(Cmp(0, 0) == 0);
	assert(Cmp(1, 0) == +1);
	assert(Cmp(0, 1) == -1);
	
	assert(Cmp("abc", "abc") == 0);
	assert(Cmp("def", "abc") == +1);
	assert(Cmp("abc", "def") == -1);
}

/**
History:
	$(HIST_VER 1.130,
		$(HIST_D オーバーロード廃止。)
		$(HIST_A in制約。)
		$(HIST_CHG pure nothrow, 無印)
	)
	$(HIST_VER 1.120,
		$(HIST_NEW)
	)
*/
bool IsIn(T)(in T Target, in T[] Args ...)
in {
	assert(Args.length);
}
body {
	foreach(ref Arg; Args) {
		if(Target == Arg) {
			return true;
		}
	}
	return false;
}
debug(cmp) unittest {
	assert(IsIn(0, [1, 2, 3, 0]));
	assert(IsIn(0, 0));
	assert(IsIn(0, 0, 1, 2, 3));
	assert(IsIn(1, 0, 1, 2, 3));
	assert(IsIn(2, 0, 1, 2, 3));
	assert(IsIn(3, 0, 1, 2, 3));
	assert(!IsIn(4, 0, 1, 2, 3));
}
/**
History:
	$(HIST_VER 1.130,
		$(HIST_NEW)
	)
*/
bool IsIn(alias func, T)(in T Target, in T[] Args ...)
if(!is(func == T))
{
	foreach(ref Arg; Args) {
		if(func(Target, Arg)) {
			return true;
		}
	}
	return false;
}
debug(cmp) unittest {
	bool a(int b, int c) {
		return b == c;
	}
	assert(!IsIn!(a)(1, 2, 3));
	assert(IsIn!(a)(1, 2, 3, 1));
}

/**
History:
	$(HIST_VER 1.130,
		$(HIST_CHG 属性, 無印, pure nothrow)
		$(HIST_CHG 名前, between, Between)
	)
	$(HIST_VER 1.120,
		$(HIST_NEW)
	)
*/
pure nothrow bool Between(T)(in T Target, in T Small, in T Big) {
	return Small <= Target && Target <= Big;
}
debug(cmp) unittest {
	assert(Between(0, 0, 100));
	assert(Between(10, 0, 100));
	assert(Between(100, 0, 100));
	assert(!Between(-1, 0, 100));
	assert(!Between(101, 0, 100));
}
alias Between between;

