﻿/**

*/
module etc.negui.system.utility.dbg;

debug import etc.negui.nestdio: wl=writefln;
debug(dbg) void main() {}

import win32.winbase;

debug import etc.negui.nestdio;
import etc.negui.system.text;

///
struct DEBUG {
static:
	/**
	History:
		$(HIST_VER 1.130,
			$(HIST_CHG 引数の型, T, in T)
		)
	*/
	void put(T...)(in T Arg) {
		OutputDebugString(Text(Arg).ptr);
	}
	void trace(string _file=__FILE__, int _line=__LINE__, T...)(lazy T Arg) {
		auto OutputData=Text("%s(%s) %s", _file, _line, Text(Arg));
		put(OutputData);
		writeln(OutputData);
	}
	
	alias DebugBreak breakPoint;

}

debug(dbg) unittest {
	int a;
	DEBUG.put("AAA");
	DEBUG.put("<%s>", a);
	a = 999;
	DEBUG.trace(a);
	DEBUG.breakPoint;
	DEBUG.trace(200);
}


