﻿/**

*/
module etc.negui.window.menu.datamenu;

debug import std.stdio: wl = writefln;
debug(datamenu) void main() {}

debug import std.string;

import win32.windows;

import etc.negui.system.base;
import etc.negui.draw.icon;
import etc.negui.input.keyboard.keyboard;
import etc.negui.negui;
public import etc.negui.window.menu.menu;
public import etc.negui.window.menu.popup;
public import etc.negui.window.menu.ownerdraw;

/**
オーナードローとアイテムの所持。
*/
class DataMenu(T): OwnerDrawMenu {
	protected {
		/// 
		T[COMMAND_ID] Datas;
	}
	/**
	History:
		$(HIST_VER 1.100,
			$(HIST_S Suicideに影響されていた。)
		)
	*/
	override protected void Kill() {
		auto Values=this.Datas.values;
		foreach(key; this.Datas.keys) {
			this.Datas.remove(key);
		}
		this.Datas = null;
		super.Kill();
	}
	
	override this(const ref SIZE Size) {
		super(Size);
	}
	override this(Icon.FIXED IconFixed) {
		super(IconFixed);
	}

	///
	bool insert(ref const(MENUITEM) MenuItem, DRAWMENUITEM* DrawItem, T Data) {
		if(super.insert(MenuItem, DrawItem)) {
			Datas[MenuItem.id] = Data;
			return true;
		}

		return false;
	}

	/**
	*/
	bool isData(COMMAND_ID Id) {
		return (Id in Datas) !is null;
	}
	/// 保持しているDATA参照。
	T data(COMMAND_ID Id)
	in {
		assert(isData(Id));
	}
	body {
		return Datas[Id];
	}
}



