﻿/**
ウィンドウ表示。

ウィンドウを表示するだけ。
*/

import etc.negui.allimport;


// メイン
int NeGuiMain(HINSTANCE hInstance, CommandLine Argument, SHOW Show) {
	auto mywnd=new MyWindow;
	return mywnd.execute;
}
mixin WinMain!(NeGuiMain);

// メインウィンドウ
class MyWindow: MainWindow {
	override protected {
		// ウィンドウ生成
		void OnCreate() {
			// タイトル設定
			text = Text("Window Sample");
		}
		// ウィンドウ生成終了
		void OnCreated() {
			// タイトルバーあり
			caption = true;
			// システムメニューあり
			systemMenu = true;
			// サイズ変更用境界線あり
			frameSize = true;
			// サイズの設定
			size(200, 200);
			// デスクトップの中心に移動
			toCenter(CENTER.DESKTOP);
			// 表示
			setShow(SHOW.SHOWNORMAL);
		}
	}
}

